#include <stdio.h>
#include <math.h>
#define MAX 200

int Dist(int a, int b);
int findlast(void);
int nearest(int x);
int Choose(int x, int y);
void PrintEven(int x);
void PrintOdd(int x);

int n,brpos;
int arr[MAX][MAX];
int first[MAX/2+1];
int last[MAX/2+1];
int pos[MAX];

struct
{
 int x;
 int y;
} mas[MAX];

int main()
{int i,p,k;

/*** INIT *******************************************************************/
 scanf("%d",&n);
 for(i=0; i<n; i++) scanf("%d %d",&mas[i].x,&mas[i].y);
 for(i=0; i<n; i++)
  for(p=0; p<n; p++)
   arr[i][p]=Dist(i,p);
 for(i=0; i<n; i++) pos[i]=0;
 pos[0]=1;
/****************************************************************************/
 brpos=1;
 first[0]=0;
 last[0]=findlast();
 for(i=1;;i++)
   {
   first[i]=nearest(first[i-1]);
   if(brpos==n) {PrintOdd(i);break;}
   last[i]=nearest(last[i-1]);
   if(brpos==n) {PrintEven(i);break;}
   }
return 0;
}

int Dist(int a, int b)
{
 return (abs(mas[a].x-mas[b].x)+abs(mas[a].y-mas[b].y));
}

int findlast(void)
{int i,ans;
 int max=0;
 for(i=1; i<n; i++)
  if(arr[i][0]>max)
    {
    max=arr[i][0];
    ans=i;
    } else
  if(arr[i][0]==max) ans=Choose(ans,i);
 pos[ans]=1;
 brpos++;
 return ans;
}

int nearest(int x)
{int i,ans;
 int min=32000;
 for(i=1; i<n; i++)
  if((!pos[i])&&(arr[x][i]<min))
    {
    min=arr[x][i];
    ans=i;
    } else
  if((!pos[i])&&(arr[x][i]==min)) ans=Choose(ans,i);
 pos[ans]=1;
 brpos++;
 return ans;
}

int Choose(int x, int y)
{int max1,max2,i,p;
 max1=max2=0;
 for(i=1; i<n; i++)
  for(p=1; p<n; p++)
   {
   if((!pos[i])&&(i!=x)&&(p!=x))
    if(arr[p][i]>max1) max1=arr[p][i];
   if((!pos[i])&&(i!=y)&&(p!=y))
    if(arr[p][i]>max2) max2=arr[p][i];
   }
 if(max1>max2) return y; else return x;
}

void PrintOdd(int x)
{int i;
 for(i=0; i<=x; i++) printf("%d ",first[i]+1);
 for(i=x-1;i>0; i--) printf("%d ",last[i]+1);
 printf("%d\n",last[0]+1);
}

void PrintEven(int x)
{int i;
 for(i=0; i<=x; i++) printf("%d ",first[i]+1);
 for(i=x;i>0; i--) printf("%d ",last[i]+1);
 printf("%d\n",last[0]+1);
}