Type
 TNeighbours = Record
                N1,N2 : Integer;
               End;

 TCard = Record
          A,B,C,D    : Integer;
          NumTriples : Integer;
          Neighbours : Array[1..81] Of TNeighbours;
          Exist      : Boolean;
         End;
Var
 F2       : Text;
 Ind,
 NumCards : Integer;
 I,J,K,L  : Integer;
 Cards    : Array[1..128] Of TCard;

{ Procedure SwapNeighbours(N1,N2 : TNeighbours);
 Var
  Temp : TNeighbours;
 Begin
  Temp := N1;
  N1 := N2;
  N2 := Temp;
 End;}

 Function Same(X1,X2,X3 : Integer) : Boolean;
 Begin
  Same := (X1=X2) and (X2=X3);
 End;

 Function Diff(X1,X2,X3 : Integer) : Boolean;
 Begin
  Diff := (X1<>X2) and (X2<>X3) and (X1<>X3);
 End;

 Function IsTriple(C1,C2,C3 : TCard) : Boolean;
 Begin
  IsTriple := (Same(C1.A,C2.A,C3.A) or Diff(C1.A,C2.A,C3.A)) and
              (Same(C1.B,C2.B,C3.B) or Diff(C1.B,C2.B,C3.B)) and
              (Same(C1.C,C2.C,C3.C) or Diff(C1.C,C2.C,C3.C)) and
              (Same(C1.D,C2.D,C3.D) or Diff(C1.D,C2.D,C3.D));
 End;

 Procedure SwapCards(IC1,IC2 : Integer);
 Var
  C1,C2,
  Temp   : TCard;
  Ix,Jx  : Integer;
 Begin
  C1 := Cards[IC1];
  C2 := Cards[IC2];

  For Ix:=1 To 81 Do
   For Jx:=1 To 81 Do
    Begin
     If Cards[Ix].Neighbours[Jx].N1 = IC1 Then
      Cards[Ix].Neighbours[Jx].N1 := IC2
     Else
      If Cards[Ix].Neighbours[Jx].N1 = IC2 Then
       Cards[Ix].Neighbours[Jx].N1 := IC1;

     If Cards[Ix].Neighbours[Jx].N2 = IC1 Then
      Cards[Ix].Neighbours[Jx].N2 := IC2
     Else
      If Cards[Ix].Neighbours[Jx].N2 = IC2 Then
       Cards[Ix].Neighbours[Jx].N2 := IC1;
    End;

  Temp := C1;
  C1   := C2;
  C2   := Temp;
 End;

Begin
 For I:=0 To 2 Do
  For J:=0 To 2 Do
   For K:=0 To 2 Do
    For L:=0 To 2 Do
     Begin
      Inc(Ind);
      Cards[Ind].A := I;
      Cards[Ind].B := J;
      Cards[Ind].C := K;
      Cards[Ind].D := L;
      Cards[Ind].NumTriples := 0;
      Cards[Ind].Exist := True;
     End;

 For I:=1 To 81 Do
  For J:=1 To 81 Do
   Begin
    Cards[I].Neighbours[J].N1 := 82;
    Cards[I].Neighbours[J].N2 := 83;
   End;

 Cards[82].Exist := False;
 Cards[83].Exist := False;

 For I:=1 To 81 Do
  For J:=I+1 To 81 Do
   For K:=J+1 To 81 Do
    If IsTriple(Cards[I],Cards[J],Cards[K]) Then
     Begin
     {For I}
      Inc(Cards[I].NumTriples);
      Cards[I].Neighbours[Cards[I].NumTriples].N1 := J;
      Cards[I].Neighbours[Cards[I].NumTriples].N2 := K;
     {For J}
      Inc(Cards[J].NumTriples);
      Cards[J].Neighbours[Cards[J].NumTriples].N1 := I;
      Cards[J].Neighbours[Cards[J].NumTriples].N2 := K;
     {For K}
      Inc(Cards[K].NumTriples);
      Cards[K].Neighbours[Cards[K].NumTriples].N1 := I;
      Cards[K].Neighbours[Cards[K].NumTriples].N2 := J;
     End;

 {Selection sort}
  For I:=1 To 81 Do
   For J:=I+1 To 81 Do
    If Cards[J].Exist Then
    If Cards[I].NumTriples < Cards[J].NumTriples Then
     SwapCards(I, J);

{ For I:=1 To 81 Do Write(Cards[I].NumTriples, ' ');}

 NumCards := 80;
 Ind := 1;
 Repeat
{Remove the most unpleasant card}
{ Writeln(NumCards, ' ',Cards[1].NumTriples);
 Readln;
 For I:=1 To 81 Do
  Begin
   Write(Cards[1].Neighbours[I].N1, ' ', Cards[1].Neighbours[I].N2);
   Readln;
  End;    }
  SwapCards(1, Ind);
  Cards[1].Exist := False;
  For I:=1 To 81 Do
   Begin
    If Cards[Cards[1].Neighbours[I].N1].Exist Then
     Begin
      Dec(Cards[Cards[1].Neighbours[I].N1].NumTriples);
{      Writeln(Cards[1].Neighbours[I].N1, ' ',Cards[Cards[1].Neighbours[I].N1].NumTriples);}
     End;
    If Cards[Cards[1].Neighbours[I].N2].Exist Then
     Dec(Cards[Cards[1].Neighbours[I].N2].NumTriples);
   End;
 {Try to find the next}

{ For i:=1 to 81 Do
  if cards[i].exist then
  begin
   write('e ',i);
   readln;
  end;}

  Ind := 2;
  For I:=2 To 81 Do
   If Cards[I].Exist Then
    Begin
     Ind := I;
     Break;
    End;
   For I:=2 To 81 Do
    If Cards[I].Exist Then
     If Cards[Ind].NumTriples < Cards[I].NumTriples Then
      Begin
       Ind := I;
      End;

  Cards[Ind].Exist := False;
  Dec(NumCards);
{  Writeln('Swap 1 and ', Ind);
  Readln;}
 Until (Cards[Ind].NumTriples <= 0) or (NumCards<=0);

 Assign(F2, 'SETFREE.TrT');
 Rewrite(F2);
 Writeln(F2, NumCards);
 For I:=1 To 81 Do
  If Cards[I].Exist Then
   Writeln(F2, Cards[I].A, ' ', Cards[I].B, ' ', Cards[I].C, ' ', Cards[I].D);

 Close(F2);

 {Anaother check part}

 Assign(F2, 'setfree.txt');
 Reset(F2);
 Readln(F2,ind);
 For I:=1 To ind Do
  Readln(F2, Cards[I].A, Cards[I].B,  Cards[I].C, Cards[I].D);
writeln('fghgdfg');
 For I:=1 To ind Do
  For J:=1 To ind Do
   For K:=1 To ind Do
    If Diff(I,J,K) Then
     If IsTriple(Cards[I],Cards[J],Cards[K]) Then
      Writeln('!!!', I, ' ', J, ' ', K);
 Close(F2);
End.