#include <fstream.h>
#include <math.h>
#include <stdlib.h>

#define INF 50000
#define MAX 300

 typedef unsigned long ul;

 typedef struct tv
  {
   long num;
   long x;
   long y;
  };


 const double k = 1.0;
 const double l = 1.0;


 ul up[300],low[300];

 tv g[300];

 ul d(int a,int b)
  {
   return abs(g[a].x-g[b].x)+abs(g[a].y-g[b].y);
  };


 int grow(const void *a,const void* b)
  {
   int left,right;
   left=*(int*)a;
   right=*(int*)b;
   if (g[left].x<=g[right].x)
    return -1;
   else
    return 1;
  };

 ul i,N,j;

 int dec(const void *a,const void* b)
  {
   int left,right;
   left=*(int*)a;
   right=*(int*)b;
   if (g[left].x>=g[right].x)
    return -1;
   else
    return 1;
  };


 int main()
  {

   cin >> N;

   for (i=1;i<=N;i++)
    {
     cin >> g[i].x >> g[i].y;
     g[i].num=i;
    };


   // find leftmost
  ul Vminx,minx=20000,sumy=0,razd;
  double rzd=20000.0,avg,tmp;
  for (i=1;i<=N;i++)
   {
    if (g[i].x<minx)
     {
      Vminx=i;
      minx=g[i].x;
     };
    sumy+=g[i].y;
   };
  sumy-=g[Vminx].y;
  avg=((sumy+0.01)/(N-1.01));
  for (i=1;i<=N;i++)
   {
    if (i==Vminx)
     continue;
    tmp=k*fabs(g[i].y-avg)-l*g[i].x;
    if (tmp<rzd)
     {
      rzd=tmp;
      razd=i;
     };
   };
  // set up and low arrays
  ul upind=0,lowind=0;
  for (i=1;i<=N;i++)
   {
    if (i==razd || i==Vminx)
     continue;
    if ( (g[Vminx].y-g[razd].y)*g[i].x + (g[razd].x-g[Vminx].x)*g[i].y
     + g[Vminx].x*g[razd].y-g[Vminx].y*g[razd].x >=0)
      {
       up[upind]=i;
       upind++;
      }
     else
      {
       low[lowind]=i;
       lowind++;
      };
   };
   qsort((void*)up,upind,sizeof(up[0]),grow);
   qsort((void*)low,lowind,sizeof(low[0]),dec);
   cout << Vminx <<" ";
   if (upind>0)
    for (i=0;i<upind;i++)
     cout<<up[i]<<" ";
   cout << razd <<" ";
   if (lowind>0)
    {
     for (i=0;i<lowind-1;i++)
      cout<<low[i]<<" ";
     cout<<low[lowind-1];
    };
  };