type
  TCo = record
           x, y, num : integer;
         end;

var
  a, b, n, br : integer;
  graph : array[1..200, 1..200] of integer;
  co : array[1..200] of TCo;
  vis : array[1..200] of boolean;
  path : array[1..200] of integer;
  good : boolean;
  brt : dword;

Procedure ReadInp;
  begin
    readln(n);
    for a := 1 to n do
    begin
      co[a].num := a;
      readln(co[a].x, co[a].y);
    end;
    FillByte(graph, SizeOf(graph), 0);
  end;

Procedure CalcDis;
var
  t : integer;
  begin
    for a := 1 to n do
      for b := a + 1 to n do
      begin
        t := abs(co[a].x - co[b].x) + abs(co[a].y - co[b].y);
        graph[a,b] := t;
        graph[b,a] := t;
      end;
  end;

Procedure FindCycle(v, t1 : integer);
var
  i : integer;
  begin
    vis[v] := true;
    if good then exit;
    if t1 = n then
      if graph[v,1] > 0 then
      begin
        good := true;exit;
      end;
    for i := 1 to n do
      if (not vis[i]) and (graph[v,i] > 0) then FindCycle(i, t1+1);
    vis[v] := false;
  end;

Procedure Solution;
var
  max, fa, fb : integer;
  begin
    brt := 0;
    br := n * n;
    repeat
      max := -1;
      for a := 1 to n do
        for b := 1 to n do
          if graph[a,b] > max then
          begin
            max := graph[a,b];
            fa := a;fb := b;
          end;
      graph[fa,fb] := -1;
      good := false;
      FillChar(vis, SizeOf(vis), false);
      FindCycle(1,1);
      if not good then graph[fa,fb] := 1
      else dec(br);
    until (br = n - 1) or (max = 1);
    br := 0;
    FillChar(vis, SizeOf(vis), false);
    good := false;
  end;

Procedure Scan(v, t : integer);
var
  i : integer;
  begin
    vis[v] := true;
    if good then exit;
    if t = n then
      if graph[v,1] > 0 then
      begin
        good := true;
        inc(br);path[br] := v;
        exit;
      end;
    for i := 1 to n do
      if (not vis[i]) and (graph[v,i] >= 1) then Scan(i, t+1);
    vis[v] := false;
    if good then
    begin
      inc(br);path[br] := v;
    end;
  end;

Procedure Sort;
var
  fl : boolean;
  temp : TCo;
  begin
    repeat
      fl := false;
      for a := 1 to n-1 do
        if co[a].x > co[a+1].x then
        begin
          temp := co[a];
          co[a] := co[a+1];
          co[a+1] := temp;
          fl := true;
        end;
    until fl = false;
  end;

begin
  ReadInp;
  CalcDis;
  if n < 50 then
  begin
    Solution;
    Scan(1,1);
    for a := br downto 1 do write(path[a], ' ');
  end
  else
  begin
    Sort;
    for a := 1 to n do write(co[a].num, ' ');
  end;
end.
