#include <stdlib.h>
#include <stdio.h>

const int N = 201;
struct Point{
int x,y;
};

Point p[N];
long a[N][N];
long used[N];
long stack[N];
long sol[N];
long best=99999;
long i,j,n;


void Input(){

        scanf("%d",&n);
	for(i=1;i<=n;i++)
		scanf("%d%d",&p[i].x,&p[i].y);
}

void Solve(){
	for(i=1;i<=n;i++)
		for(j=1;j<=n;j++)
			a[i][j] = abs(p[i].x - p[j].x) + abs(p[i].y - p[j].y);
}


void DFS(int last,int dist,int step){
	if(dist > best) return;
	if(step == n && dist+a[last][1] < best) {
		best=dist+a[last][1];
		for(i=0;i<=stack[0];i++)
			sol[i] = stack[i];
		return;
		}

	for(int i=1;i<=n;i++)
		if(!used[i]){
			stack[0]++;
			stack[stack[0]]=i;
			used[i]=1;
			DFS(i,dist + a[last][i],step+1);

			used[stack[stack[0]]]=0;
			stack[stack[0]]=0;
			stack[0]--;
	}


}

void PrintResult(){
	for(i=1;i<=sol[0];i++)
		printf("%d ",sol[i]);
	printf("\n");
}

int main(){
	Input();
	Solve();
	used[1]=1;
	stack[0]=1;
	stack[1]=1;
	DFS(1,0,1);
	PrintResult();
return 0;
}




































































































