#include<stdio.h>
#include<stdlib.h>
#include<values.h>

#define YES 1
#define NO 0
#define MAX 201

struct place {
 long x,y;
 char visited;
};

int perm[MAX],best_perm[MAX];
unsigned long prize=0,best_prize=MAXLONG;
unsigned long huge prize_table[MAX][MAX];
place arr[MAX];
int N,perm_len=2;

void load() {
   scanf("%d",&N);
   for (int i=1;i<=N;i++) {
      scanf("%ld",&arr[i].x);
      scanf("%ld",&arr[i].y);
      arr[i].visited=NO;
      perm[i]=0;
   }
   arr[1].visited=YES;
   perm[1]=1;
}
unsigned long calc_prize(int i,int j) {
   return (labs(arr[i].x-arr[j].x)+labs(arr[i].y-arr[j].y));
}
void calc() {
 unsigned long temp;
   for (int i=1;i<=N;i++) {
      for (int j=1;j<=N;j++) {
	 temp=calc_prize(i,j);
	 prize_table[i][j]=temp;
	 prize_table[j][i]=temp;
      }
   }
}
//--------------
void solve(int index) {
   if (prize>best_prize) return;
   if (perm_len==N+1&&prize<best_prize) {
      for (int x=1;x<=N;x++) {
	 best_perm[x]=perm[x];
      }
      best_prize=prize;
      return;
   }
   for (int i=1;i<=N;i++) {
      if (i==index) continue;
      if (arr[i].visited==YES) continue;
      prize+=prize_table[index][i];
      perm[perm_len]=i;
      perm_len++;
      arr[i].visited=YES;
      solve(i);
      prize-=prize_table[index][i];
      arr[i].visited=NO;
      perm_len--;
   }
}
void show() {
   //printf("%lu\n",best_prize);
   for (int i=1;i<=N;i++) {
      printf("%d ",best_perm[i]);
   }
}

void main() {
   //freopen("TRAVEL.txt","r",stdin);
   load();
   //fclose(stdin);
   calc();
   solve(1);
   show();
}
