#include <iostream.h>
#include <fstream.h>
#include <math.h>

const char Input[] = "travel_i.txt";
const char Output[] = "travel_o.txt";

typedef struct
{ int x, y, num;
} TPoint;

int Length(TPoint, TPoint);
void Permut(TPoint Places[], int count);
unsigned long fact(int);
unsigned long CalcLen(TPoint Places[], int count);
void Rev(TPoint *Places, int count);

void main()
{ TPoint *Places;
  int count;
  ifstream inp(Input);
  inp >> count;
  Places = new TPoint[count];
  int i;
  for (i = 0; i < count; i++)
  { inp >> Places[i].x >> Places[i].y;
    Places[i].num = i;
  }
/*  for (i = 0; i < count; i++)
  { cout << Places[i].num << " " << Places[i].x << " " << Places[i].y << endl;
  }*/
  Permut(Places, count);
/*  for (i = 0; i < count; i++)
  { cout << Places[i].x << " " << Places[i].y << endl;
  } */
}

int Length(TPoint p1, TPoint p2)
{ return abs(p1.x - p2.x) + abs(p1.y - p2.y); 
}

void Permut(TPoint Places[], int count)
{ int i, j, k = 0;
  int Pod[200];
  TPoint w;
  unsigned long min = 2147483647, curr;
  int permcount = fact(count);
  while (permcount >= 1)
  for (i = count - 1; i >= 1; i--)
  { if (permcount % 2 == 0)
      Rev(Places, count);
    else
    { w = Places[i];
      Places[i] = Places[i - 1];
      Places[i - 1] = w;
    }
    permcount--;
    curr = CalcLen(Places, count);
/*    int z;
    for (z = 0; z < count; z++)
      cout << Places[z].num << " ";*/
//    cout << endl;
    if (min > curr)
    { min = curr;
      for (k = 0; k < count; k++)
      { Pod[k] = Places[k].num;
      }
    }
  }
//  cout << min << " ";
  ofstream out(Output);
  for (i = 0; i < count; i++)
  { out << Pod[i] + 1<< " ";
  }


}

unsigned long CalcLen(TPoint Places[], int count)
{ unsigned long rez = 0;
  int i;
  for (i = 0; i < count - 1; i++)
  { rez += Length(Places[i], Places[i + 1]); 
  }
  return rez;
}

unsigned long fact(int n)
{ unsigned long i, rez = 1;
  for (i = n; i > 1; i--)
    rez *= i;
  return rez;
}

void Rev(TPoint *Places, int count)
{ int m = count / 2, i;
  TPoint x;
  for (i = 0; i < m; i++)
  { x = Places[i];
    Places[i] = Places[count - i - 1];
    Places[count - i - 1] = x;
  }
}