#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <limits.h>
#include <time.h>

FILE *inp;
FILE *out;

int N;//4..199
int x[199 + 1];
int y[199 + 1];
int D[199 + 1][199 + 1];
int a[199 + 1];
int bestval;
int best[199 + 1];
int FIN;

__inline__ void swap(int *a, int *b) {
	int tmp;
	tmp = *a;
	*a = *b;
	*b = tmp;
}

void printSolution(void) {
	int i;
	for (i = 1; i < N; i++) {
		fprintf(out, "%d ", best[i]);
	}
	fprintf(out, "%d\n", best[N]);
/*	fprintf(out, "%d\n", bestval);*/
}

/*
void sighand(int sign) {
	int i;
	fprintf(stderr, "sighand\n");
	for (i = 1; i < N; i++) {
		fprintf(out, "%d ", best[i]);
	}
	fprintf(out, "%d\n", best[N]);
/ *	printSolution();* /
	exit(0);
}
*/

void go() {
	int i;
	int ind;
	int tmp;
	int curval;
	bestval = INT_MAX;
	for (i = 0; i <= N; i++) a[i] = i;
	for ( ; ; ) {
		for (i = N - 1; ;i--) {
			if (a[i] < a[i + 1]) break;
		}
		ind = i;
		if (ind == 1) break;

		tmp = i + 1;
		for (i = ind + 1; i <= N; i++) {
			if (a[i] > a[ind] && a[i] < a[tmp]) tmp = i;
		}
		swap(&a[ind], &a[tmp]);
		for (i = ind + 1; i <= (ind + N) / 2; i++) {
			swap(&a[i], &a[N + ind - i + 1]);
		}
		/*
		for (i = 1; i <= N; i++) fprintf(out, "%d ", a[i]);
		fprintf(out, "\n");
		*/
		curval = 0;
		for (i = 1; i < N; i++) {
			curval += D[a[i]][a[i + 1]];
		}
		curval += D[a[N]][a[1]];
		if (curval < bestval) {
			for (i = 1; i <= N; i++) best[i] = a[i];
			bestval = curval;
		}
		if (clock() > FIN) {
			/*fprintf(out, "No time. Finishing...\n");*/
			printSolution();
			return;
		}
	}
	printSolution();
}


int main(void) {
	int i;
	int j;
/*	inp = fopen("travel.inp", "rt");*/
	inp = stdin;
/*	out = fopen("travel.out", "wt");*/
	out = stdout;

	/*signal(SIGALRM, sighand);*/

	fscanf(inp, "%d", &N);

	for (i = 1; i <= N; i++) {
		fscanf(inp, "%d %d", &x[i], &y[i]);
	}
	for (i = 1; i <= N; i++) {
		for (j = 1; j <= N; j++) {
			D[i][j] = abs(x[i] - x[j]) + abs(y[i] - y[j]);
		}
	}
/*	alarm(4);*/
	/*
	for (i = 1; i <= N; i++)
		for (j = 1; j <= N; j++) {
			fprintf(out, "D[%d][%d]=%d\n", i, j, D[i][j]);
		}
	*/

	FIN = (int)(4.9 * CLOCKS_PER_SEC);
	clock();
	go();
	return 0;
}