#include <fstream.h>

void init(void);
int nemnoj(int i, int j, int k);
void outp(void);

typedef struct card {
	unsigned int a : 2;
	unsigned int b : 2;
	unsigned int c : 2;
	unsigned int d : 2;
	unsigned int mnoj : 1;
};
const int n = 81;
card arr[n];

int main (){
	int i, j, k;

	init();
	for(i = 0; i < n; i++)
		for(j = i + 1; j < n; j++)
			for(k = j + 1; k < n; k++){
				if((arr[i].mnoj == 1)&&(arr[j].mnoj == 1)&&(arr[k].mnoj == 1))
					arr[k].mnoj = nemnoj(i, j, k);
			}
	outp();
	return 0;
}

void init(void){
	int i, j, k, l, m = 0;
	for(i = 0; i < 3; i++)
		for(j = 0; j < 3; j++)
			for(k = 0; k < 3; k++)
				for(l = 0; l < 3; l++){
					arr[m].a = i;
					arr[m].b = j;
					arr[m].c = k;
					arr[m].d = l;
					arr[m].mnoj = 1;
					m++;
				}
}

int nemnoj(int i, int j, int k){
	if(((arr[i].a != arr[j].a)&&(arr[j].a != arr[k].a))||
	  ((arr[i].a == arr[j].a)&&(arr[j].a == arr[k].a)))

		if(((arr[i].b != arr[j].b)&&(arr[j].b != arr[k].b))||
		  ((arr[i].b == arr[j].b)&&(arr[j].b == arr[k].b)))

			if(((arr[i].c != arr[j].c)&&(arr[j].c != arr[k].c))||
			  ((arr[i].c == arr[j].c)&&(arr[j].c == arr[k].c)))

				if(((arr[i].d != arr[j].d)&&(arr[j].d != arr[k].d))||
				  ((arr[i].d == arr[j].d)&&(arr[j].d == arr[k].d)))
					return 0;
	return 1;
}

void outp(void){
	ofstream out("setfree.txt");
	int i, broj = 0;

	for(i = 0; i < n; i++)
		if(arr[i].mnoj == 1)
			broj++;

	out << broj << endl;
	for(i = 0; i < n; i++)
		if(arr[i].mnoj == 1){
			out << arr[i].a << " ";
			out << arr[i].b << " ";
			out << arr[i].c << " ";
			out << arr[i].d << " " << endl;
		}
}
